GIT-RESET(1)

NAME
git-reset - Reset current HEAD to the specified state

SYNOPSIS

git reset [--mixed | --soft | --hard | --merge | --keep] [-q] [<commit>]
git reset [-q] [<commit>] [--] <paths>...
git reset --patch [<commit>] [--] [<paths>...]

DESCRIPTION

Sets the current head to the specified commit and optionally resets the index and working tree to match.

This command is useful if you notice some small error in a recent commit (or set of commits) and want to redo that part without showing the undo in the history.

If you want to undo a commit other than the latest on a branch, git-revert(1) is your friend.

The second and third forms with paths and/or --patch are used to revert selected paths in the index from a given commit, without moving HEAD.

OPTIONS

--mixed
    Resets the index but not the working tree (i.e., the changed files are preserved but not marked for commit) and reports what has not been updated. This is the default action.

--soft
    Does not touch the index file nor the working tree at all, but requires them to be in a good order. This leaves all your changed files "Changes to be committed", as git status would put it.

--hard
    Matches the working tree and index to that of the tree being switched to. Any changes to tracked files in the working tree since <commit> are lost.

--merge
    Resets the index to match the tree recorded by the named commit, and updates the files that are different between the named commit and the current commit in the working tree.

--keep
    Reset the index to the given commit, keeping local changes in the working tree since the current commit, while updating working tree files without local changes to what appears in the given commit. If a file that is different between the current commit and the given commit has local changes, reset is aborted.

-p, --patch
    Interactively select hunks in the difference between the index and <commit> (defaults to HEAD). The chosen hunks are applied in reverse to the index.

    This means that git reset -p is the opposite of git add -p (see git-add(1)).

-q, --quiet
    Be quiet, only report errors.

<commit>
    Commit to make the current HEAD. If not given defaults to HEAD.

DISCUSSION

The tables below show what happens when running:

    git reset --option target

to reset the HEAD to another commit (target) with the different reset options depending on the state of the files.

In these tables, A, B, C and D are some different states of a file. For example, the first line of the first table means that if a file is in state A in the working tree, in state B in the index, in state C in HEAD and in state D in the target, then "git reset --soft target" will put the file in state A in the working tree, in state B in the index and in state D in HEAD.

    working index HEAD target         working index HEAD
    ----------------------------------------------------
     A       B     C    D     --soft   A       B     D
                              --mixed  A       D     D
                              --hard   D       D     D
                              --merge (disallowed)
                              --keep  (disallowed)

    working index HEAD target         working index HEAD
    ----------------------------------------------------
     A       B     C    C     --soft   A       B     C
                              --mixed  A       C     C
                              --hard   C       C     C
                              --merge (disallowed)
                              --keep   A       C     C

    working index HEAD target         working index HEAD
    ----------------------------------------------------
     B       B     C    D     --soft   B       B     D
                              --mixed  B       D     D
                              --hard   D       D     D
                              --merge  D       D     D
                              --keep  (disallowed)

    working index HEAD target         working index HEAD
    ----------------------------------------------------
     B       B     C    C     --soft   B       B     C
                              --mixed  B       C     C
                              --hard   C       C     C
                              --merge  C       C     C
                              --keep   B       C     C

    working index HEAD target         working index HEAD
    ----------------------------------------------------
     B       C     C    D     --soft   B       C     D
                              --mixed  B       D     D
                              --hard   D       D     D
                              --merge (disallowed)
                              --keep  (disallowed)

    working index HEAD target         working index HEAD
    ----------------------------------------------------
     B       C     C    C     --soft   B       C     C
                              --mixed  B       C     C
                              --hard   C       C     C
                              --merge  B       C     C
                              --keep   B       C     C

"reset --merge" is meant to be used when resetting out of a conflicted merge. Any mergy operation guarantees that the work tree file that is involved in the merge does not have local change wrt the index before it starts, and that it writes the result out to the work tree. So if we see some difference between the index and the target and also between the index and the work tree, then it means that we are not resetting out from a state that a mergy operation left after failing with a conflict. That is why we disallow --merge option in this case.

"reset --keep" is meant to be used when removing some of the last commits in the current branch while keeping changes in the working tree. If there could be conflicts between the changes in the commit we want to remove and the changes in the working tree we want to keep, the reset is disallowed. That's why it is disallowed if there are both changes between the working tree and HEAD, and between HEAD and the target. To be safe, it is also disallowed when there are unmerged entries.

The following tables show what happens when there are unmerged entries:

    working index HEAD target         working index HEAD
    ----------------------------------------------------
     X       U     A    B     --soft  (disallowed)
                              --mixed  X       B     B
                              --hard   B       B     B
                              --merge  B       B     B
                              --keep  (disallowed)

    working index HEAD target         working index HEAD
    ----------------------------------------------------
     X       U     A    A     --soft  (disallowed)
                              --mixed  X       A     A
                              --hard   A       A     A
                              --merge  A       A     A
                              --keep  (disallowed)

X means any state and U means an unmerged index.

EXAMPLES

Undo a commit and redo

        $ git commit ...
        $ git reset --soft HEAD^      (1)
        $ edit                        (2)
        $ git commit -a -c ORIG_HEAD  (3)

    1. This is most often done when you remembered what you just committed is incomplete, or you misspelled your commit message, or both. Leaves working tree as it was before "reset".
    2. Make corrections to working tree files.
    3. "reset" copies the old head to .git/ORIG_HEAD; redo the commit by starting with its log message. If you do not need to edit the message further, you can give -C option instead.

    See also the --amend option to git-commit(1).

Undo commits permanently

        $ git commit ...
        $ git reset --hard HEAD~3   (1)

    1. The last three commits (HEAD, HEAD^, and HEAD~2) were bad and you do not want to ever see them again. Do not do this if you have already given these commits to somebody else. (See the "RECOVERING FROM UPSTREAM REBASE" section in git-rebase(1) for the implications of doing so.)

Undo a commit, making it a topic branch

        $ git branch topic/wip     (1)
        $ git reset --hard HEAD~3  (2)
        $ git checkout topic/wip   (3)

    1. You have made some commits, but realize they were premature to be in the "master" branch. You want to continue polishing them in a topic branch, so create "topic/wip" branch off of the current HEAD.
    2. Rewind the master branch to get rid of those three commits.
    3. Switch to "topic/wip" branch and keep working.

Undo add

        $ edit                                     (1)
        $ git add frotz.c filfre.c
        $ mailx                                    (2)
        $ git reset                                (3)
        $ git pull git://info.example.com/ nitfol  (4)

    1. You are happily working on something, and find the changes in these files are in good order. You do not want to see them when you run "git diff", because you plan to work on other files and changes with these files are distracting.
    2. Somebody asks you to pull, and the changes sounds worthy of merging.
    3. However, you already dirtied the index (i.e. your index does not match the HEAD commit). But you know the pull you are going to make does not affect frotz.c nor filfre.c, so you revert the index changes for these two files. Your changes in working tree remain there.
    4. Then you can pull and merge, leaving frotz.c and filfre.c changes still in the working tree.

Undo a merge or pull

        $ git pull                         (1)
        Auto-merging nitfol
        CONFLICT (content): Merge conflict in nitfol
        Automatic merge failed; fix conflicts and then commit the result.
        $ git reset --hard                 (2)
        $ git pull . topic/branch          (3)
        Updating from 41223... to 13134...
        Fast-forward
        $ git reset --hard ORIG_HEAD       (4)

    1. Try to update from the upstream resulted in a lot of conflicts; you were not ready to spend a lot of time merging right now, so you decide to do that later.
    2. "pull" has not made merge commit, so "git reset --hard" which is a synonym for "git reset --hard HEAD" clears the mess from the index file and the working tree.
    3. Merge a topic branch into the current branch, which resulted in a fast-forward.
    4. But you decided that the topic branch is not ready for public consumption yet. "pull" or "merge" always leaves the original tip of the current branch in ORIG_HEAD, so resetting hard to it brings your index file and the working tree back to that state, and resets the tip of the branch to that commit.

Undo a merge or pull inside a dirty work tree

        $ git pull                         (1)
        Auto-merging nitfol
        Merge made by recursive.
         nitfol                |   20 +++++----
         ...
        $ git reset --merge ORIG_HEAD      (2)

    1. Even if you may have local modifications in your working tree, you can safely say "git pull" when you know that the change in the other branch does not overlap with them.
    2. After inspecting the result of the merge, you may find that the change in the other branch is unsatisfactory. Running "git reset --hard ORIG_HEAD" will let you go back to where you were, but it will discard your local changes, which you do not want. "git reset --merge" keeps your local changes.

Interrupted workflow
    Suppose you are interrupted by an urgent fix request while you are in the middle of a large change. The files in your working tree are not in any shape to be committed yet, but you need to get to the other branch for a quick bugfix.

        $ git checkout feature ;# you were working in "feature" branch and
        $ work work work       ;# got interrupted
        $ git commit -a -m "snapshot WIP"                 (1)
        $ git checkout master
        $ fix fix fix
        $ git commit ;# commit with real log
        $ git checkout feature
        $ git reset --soft HEAD^ ;# go back to WIP state  (2)
        $ git reset                                       (3)

    1. This commit will get blown away so a throw-away log message is OK.
    2. This removes the WIP commit from the commit history, and sets your working tree to the state just before you made that snapshot.
    3. At this point the index file still has all the WIP changes you committed as snapshot WIP. This updates the index to show your WIP files as uncommitted.

    See also git-stash(1).

Reset a single file in the index
    Suppose you have added a file to your index, but later decide you do not want to add it to your commit. You can remove the file from the index while keeping your changes with git reset.

        $ git reset -- frotz.c                      (1)
        $ git commit -m "Commit files in index"     (2)
        $ git add frotz.c                           (3)

    1. This removes the file from the index while keeping it in the working directory.
    2. This commits all other changes in the index.
    3. Adds the file to the index again.

Keep changes in working tree while discarding some previous commits
    Suppose you are working on something and you commit it, and then you continue working a bit more, but now you think that what you have in your working tree should be in another branch that has nothing to do with what you commited previously. You can start a new branch and reset it while keeping the changes in your work tree.

        $ git tag start
        $ git checkout -b branch1
        $ edit
        $ git commit ...                            (1)
        $ edit
        $ git checkout -b branch2                   (2)
        $ git reset --keep start                    (3)

    1. This commits your first edits in branch1.
    2. In the ideal world, you could have realized that the earlier commit did not belong to the new topic when you created and switched to branch2 (i.e. "git checkout -b branch2 start"), but nobody is perfect.
    3. But you can use "reset --keep" to remove the unwanted commit after you switched to "branch2".

AUTHOR

Written by Junio C Hamano <gitster@pobox.com> and Linus Torvalds <torvalds@osdl.org>

DOCUMENTATION

Documentation by Junio C Hamano and the git-list <git@vger.kernel.org>.

GIT

Part of the git(1) suite